(function(f){if(typeof exports==="object"&&typeof module!=="undefined"){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}g.module = f()}})(function(){var define,module,exports;return (function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){

const events = {
    update: function(ui) {
        calcModelTerms(ui, this);
        filterModelTerms(ui, this);
    },

    onChange_ind: function(ui) {
        calcModelTerms(ui, this);
    },

    onChange_modelTerms: function(ui) {
        filterModelTerms(ui, this);
    },

    onUpdate_modelSupplier: function(ui) {
        let variableList = this.cloneArray(ui.ind.value(), []);
        ui.modelSupplier.setValue(this.valuesToItems(variableList, FormatDef.variable));
    }
};

let calcModelTerms = function(ui, context) {
    let variableList = context.cloneArray(ui.ind.value(), []);

    ui.modelSupplier.setValue(context.valuesToItems(variableList, FormatDef.variable));

    let varsDiff = context.findChanges("variableList", variableList, true, FormatDef.variable);

    let termsList = context.cloneArray(ui.modelTerms.value(), []);

    let termsChanged = false;

    for (let i = 0; i < varsDiff.removed.length; i++) {
        for (let j = 0; j < termsList.length; j++) {
            if (FormatDef.term.contains(termsList[j], varsDiff.removed[i])) {
                termsList.splice(j, 1);
                termsChanged = true;
                j -= 1;
            }
        }
    }

    if (ui.view.model.ui.label === 'Linear Regression') {
        for (let i = 0; i < varsDiff.added.length; i++)
            termsList.push([varsDiff.added[i]]);
    }
    else
        termsList = context.getCombinations(varsDiff.added, termsList);

    termsChanged = termsChanged || varsDiff.added.length > 0;

    if (termsChanged)
        ui.modelTerms.setValue(termsList);
};

let filterModelTerms = function(ui, context) {
    let termsList = context.cloneArray(ui.modelTerms.value(), []);

    let termsDiff = context.findChanges("currentList", termsList, true, FormatDef.term);

    let changed = false;
    if (termsDiff.removed.length > 0 && termsList !== null) {
        let itemsRemoved = false;
        for (let i = 0; i < termsDiff.removed.length; i++) {
            let item = termsDiff.removed[i];
            for (let j = 0; j < termsList.length; j++) {
                if (FormatDef.term.contains(termsList[j], item)) {
                    termsList.splice(j, 1);
                    j -= 1;
                    itemsRemoved = true;
                }
            }
        }

        if (itemsRemoved)
            changed = true;
    }

    if (context.sortArraysByLength(termsList))
        changed = true;

    if (changed)
        ui.modelTerms.setValue(termsList);
};

module.exports = events;

},{}],2:[function(require,module,exports){

// This file is an automatically generated and should not be edited

'use strict';

const options = [{"name":"data","type":"Data","description":{"R":"the data set as a data frame"}},{"name":"dep","title":"Dependent Variable","type":"Variable","default":null,"description":{"R":"a string specifying the dependent variable in `data`"}},{"name":"ind","title":"Independent Variables","type":"Variables","default":null,"description":{"R":"a vector of strings specifying the independent variables in `data`"}},{"name":"modelTerms","title":"Model Terms","type":"Terms","default":null,"description":{"R":"a list of string vectors specifying the model terms"}}];

const view = function() {
    
    

    View.extend({
        jus: "2.0",

        events: [

	],

	update: require('./anova.events').update

    }).call(this);
}

view.layout = ui.extend({

    label: "ANOVA",
    jus: "2.0",
    type: "root",
    stage: 0, //0 - release, 1 - development, 2 - proposed
    controls: [
		{
			type: DefaultControls.VariableSupplier,
			typeName: 'VariableSupplier',
			name: "variablesupplier",
			persistentItems: false,
			stretchFactor: 1,
			controls: [
				{
					type: DefaultControls.TargetLayoutBox,
					typeName: 'TargetLayoutBox',
					controls: [
						{
							name: "dep",
							type: DefaultControls.VariablesListBox,
							typeName: 'VariablesListBox',
							label: "Dependent Variable",
							showColumnHeaders: false,
							maxItemCount: 1,
							itemDropBehaviour: "overwrite",
							columns: [
								{
									name: "column1",
									label: null,
									stretchFactor: 1,
									template:
									{
										type: DefaultControls.VariableLabel,
										typeName: 'VariableLabel'
									}									
								}
							],
							isTarget: true
						}
					]
				},
				{
					type: DefaultControls.TargetLayoutBox,
					typeName: 'TargetLayoutBox',
					controls: [
						{
							type: DefaultControls.VariablesListBox,
							typeName: 'VariablesListBox',
							name: "ind",
							label: "Independent Variables",
							showColumnHeaders: false,
							events: [
								{ execute: require('./anova.events').onChange_ind }
							],
							columns: [
								{
									name: "column1",
									label: null,
									stretchFactor: 1,
									template:
									{
										type: DefaultControls.VariableLabel,
										typeName: 'VariableLabel'
									}									
								}
							],
							isTarget: true
						}
					]
				}
			]
		},
		{
			type: DefaultControls.CollapseBox,
			typeName: 'CollapseBox',
			label: "Model",
			collapsed: true,
			stretchFactor: 1,
			controls: [
				{
					type: DefaultControls.Supplier,
					typeName: 'Supplier',
					name: "modelSupplier",
					label: "Components",
					persistentItems: true,
					stretchFactor: 1,
					events: [
						{ onEvent: 'update', execute: require('./anova.events').onUpdate_modelSupplier }
					],
					controls: [
						{
							type: DefaultControls.TargetLayoutBox,
							typeName: 'TargetLayoutBox',
							transferAction: "interactions",
							controls: [
								{
									type: DefaultControls.ListBox,
									typeName: 'ListBox',
									name: "modelTerms",
									valueFilter: "unique",
									isTarget: true,
									itemDropBehaviour: "emptyspace",
									events: [
										{ execute: require('./anova.events').onChange_modelTerms }
									],
									template:
									{
										type: DefaultControls.TermLabel,
										typeName: 'TermLabel'
									}									
								}
							]
						}
					]
				}
			]
		}
	]
});

module.exports = { view : view, options: options };

},{"./anova.events":1}]},{},[2])(2)
});
